

MAKE (1) addendum		9/21/86 	       MAKE (1) addendum


SYSNOSIS
	make ... [-m name:body ...] ...


DESCRIPTION
	This version of make now allows limited definition of macros on
	the command line when invoking the utility. The syntax of a
	command line macro definition is:

	   -m <name>:<body>

	where <name> is the macro name and <body> is the macro text. The
	macro name, seperator, and body may not contain whitespace.

	You may define more than one macro this way, the only limitation
	being the maximum size of the comand line. However, unlike
	macros defined in the makefile, macros cannot be "undefined"
	from the command line; you must specify definition text to
	associate with the name.

	Make performs macro substitution and escape character processing
	on the command line definitions.

	Because the Lattice C start-up routine consumes any equal-sign
	characters and immediately following text that appear on the
	command line, the syntax of a command line macro definition must
	be different from the syntax used in the makefile. Sorry about
	that. Complaints should be directed to Lattice.


AUTHOR
	Richard Hargrove
	Texas Instruments, Inc.
	P.O. Box 868305, m/s 8435
	Plano, TX   75086
	214/575-4128




















				 [ 1 ]


